<?php

/**
 * Controller :: Articles
 *
 * articles_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $05.02.2007$
 */

class ArticlesController extends AppController
{
    var $name = 'Articles';
    
	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Article->setId($id);
		if ($this->Article->saveField('published', 'N')) 
		{
			$this->set('msg','The article was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The article was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Article->setId($id);
		
		if ($this->Article->saveField('published', 'Y')) 
		{
			$this->set('msg','The article was susccessfully published!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The article was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->Article->del($id)) 
		{
			$dir = WWW_ROOT . "upload" . DS . "articles" . DS . $id . DS;
			$this->Filemanager->deleteDir($dir);
			$this->Article->delComments('news', $id);
			
			$this->set('msg','The article was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The article was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_index($page = 1, $sort = 'dnb_articles.created', $direction = 'DESC', $filter = null) 
	{				
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Article->findCount(), $this->Pager->per_page, $page);
		$data = $this->Article->table($paging->offset, $paging->limit, $filter, $sort, $direction);
		
		$this->set('sort', $sort);
		$this->set('direction', $direction);
		$this->set('filter', $filter);

		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','articles');

		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - ARTICLES";
		$this->render('admin', 'admin');
		
	}
	
	function admin_filter() 
	{
		$this->Auth->checkPermissions();
		
		$paging =$this->Pager->getPagerData($this->Article->findCount("header LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->Article->table($paging->offset, $paging->limit, $_GET['filter'], $_GET['sort'], $_GET['direction']);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','articles');
		$this->set('filter', $_GET['filter']);
		$this->set('sort', $_GET['sort']);
		$this->set('direction', $_GET['direction']);
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - ARTICLES";
		$this->render('admin', 'admin');
	}
	
	function admin_add() 
	{
		$this->Auth->checkPermissions();
		$this->_back('news','/admin/articles/');	
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
		$categories = $this->requestAction('/admin/article_categories/get_news_categories/');
		$magazines = $this->requestAction('/admin/magazines/get_magazines/');
		
		
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','articles');
		$this->set('data', $this->Session->read('data'));
		$this->set('files',  $this->Session->read('files'));
		$this->set('categories',  $categories);
		$this->set('magazines',  $magazines);
		
		if(is_file($this->Session->read('dir').'perex.jpg'))
			$this->set('perex',  $this->webroot.strstr($this->Filemanager->htmlPath($this->Session->read('dir')).'perex.jpg','upload'));
		else 
			$this->set('perex', $this->webroot.'upload/news/perex.gif');
		
		$this->Session->del('data');
		$this->pageTitle = "Drumb - ARTICLES";
		$this->render('add', 'admin');
	}
	
	function admin_save()
	{
		$this->Auth->checkPermissions();
		@$this->Session->write('redirect', strstr($_SERVER['HTTP_REFERER'], '/admin'));	
		
		if($this->Session->check('id') && empty($this->data['Article']['id'])) 
		{
			$this->data['Article']['id'] = $this->Session->read('id');
			$this->Article->setId($this->data['Article']['id']);
		} 
		else 
			$this->Article->setId($this->data['Article']['id']);
		
		if($this->Article->save($this->data)) 
		{
			if(!$this->Session->check('id') && empty($this->data['Article']['id'])) 
			{
				$this->Session->write('id' ,mysql_insert_id());
				$this->data['Article']['id'] = $this->Session->read('id');
			}
			
			$dir = WWW_ROOT . "upload" . DS . "articles" . DS . $this->data['Article']['id'] . DS; 
			$this->Filemanager->createDir($dir);
			$this->Session->write('msg','<p class="success">The article was susccessfully saved!</p>');
		}
		else
			$this->Session->write('msg','<p class="error">A error occured. The article was not saved!</p>');
		
		$this->Session->write('data',$this->data);
		
		if(isset($this->data['Article']['upload'])) 
		{
			if(($origin = $this->Filemanager->upload($_FILES['file'], $dir, array('jpg', 'gif', 'jpeg', 'txt', 'doc', 'pdf', 'xls', 'mp3'), 8000000))) 
			{
				$this->Session->write('msg','<p class="success">The file was susccessfully uploaded!</p>');
				$type = pathinfo($origin, PATHINFO_EXTENSION);
				if($type == 'jpg' || $type == 'jpeg' || $type == 'gif') 
				{
					$image = getimagesize($origin);
					if($image[0] > 400)
					{
						$ratio = ($image[0] / $image[1]);
						$image[0] = 400;
						$image[1] =	(400 / $ratio);
						$this->Filemanager->imgResize($origin,$origin,$image[0],$image[1]);
					}	
				}
			}
			@$this->Filemanager->deleteFile($dir.'perex_temp.jpg');
			$this->Session->write('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
			$this->redirect($this->Session->read('redirect'));
			exit();
		} 
		elseif(isset($this->data['Article']['perex']))
		{
			if(($dest = $this->Filemanager->upload($_FILES['perex'], $dir, array('jpg', 'gif', 'jpeg'), 8000000, 'perex_temp.jpg'))) 
			{				
				$this->Session->write('dest', $dest);
				$this->Session->write('dir', $dir);
				$this->redirect('/admin/articles/perex/');
			} 
			else
				$this->redirect($this->Session->read('redirect'));
			exit();	
		} 
		else
			$this->redirect($this->Session->read('redirect'));
	}
	
	function admin_perex($action = null) 
	{
		$this->Auth->checkPermissions();
		$dest = $this->webroot.strstr($this->Filemanager->htmlPath($this->Session->read('dest')),'upload');
		$full_dest = $this->Session->read('dest');
		
		if($action == 'crop')
		{
			if($this->Filemanager->imgCrop($full_dest,$full_dest,$this->data['Article']['x'], $this->data['Article']['y'], $this->data['Article']['width'], $this->data['Article']['height'])) 
			{
				if($this->Filemanager->imgResize($full_dest,$this->Session->read('dir').'perex.jpg',100,100)) 
				{
					$this->Filemanager->deleteFile($full_dest);
					$this->Session->write('files',  $this->Filemanager->searchDir($this->Session->read('dir'),0,'FILES'));
					$this->Session->write('msg','<p class="success">Perex was susccessfully croped!</p>');
					$this->Session->del('dest');
				}
			} 
			else
				$this->Session->write('msg','<p class="error">A error occured. The Perex was not croped!</p>');
			
			$this->redirect($this->Session->read('redirect').'');
			exit();
		}
		
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/interface/croper.php" />';
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/interface/interface.php"></script>';
		$image = getimagesize($this->Session->read('dest'));
		
		if($image[0] > 800) 
		{ 
			$ratio = ($image[0] / $image[1]);
			$image[0] = 800;
			$image[1] =	(800 / $ratio);
			$this->Filemanager->imgResize($full_dest,$full_dest,$image[0],$image[1]);
		}
		
		$this->set('width', $image[0]);
		$this->set('height', $image[1]);
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','articles');
		$this->set('dest', $dest);
		
		$this->pageTitle = "Drumb - PEREX CROP";
		$this->render('crop', 'admin');
	}

	function admin_delete_file()
	{	
		$this->Auth->checkPermissions();
		$dir = WWW_ROOT . "upload" . DS . "articles" . DS . $_POST['id'] . DS . $_POST['name'];
		if($this->Filemanager->deleteFile($dir)) 
		{
			$this->set('msg','The file was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The file was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}

	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->Article->findCount("`Article`.`id`=".$id."")) == 0) 
		{
			$this->redirect('/admin/articles/');
			exit();
		}
		
		$this->Article->setId($id);
		
		if(!$this->Session->check('data'))
			$data = $this->Article->read();
		else 
		{
			$data = $this->Session->read('data');
			$this->Session->del('data');
		}
		
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
		$categories = $this->requestAction('/admin/article_categories/get_news_categories/');
		$magazines = $this->requestAction('/admin/magazines/get_magazines/');
		
		$this->set('categories',  $categories);
		$this->set('magazines',  $magazines);

		$dir = WWW_ROOT . "upload" . DS . "articles" . DS . $data['Article']['id'] . DS;
		@$this->Filemanager->deleteFile($dir.'perex_temp.jpg');
		$this->_back('articels');
		
		$this->set('data', $data);
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','articles');

		$this->set('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
		
		if(is_file($dir.'perex.jpg'))
			$this->set('perex', $this->webroot.strstr($this->Filemanager->htmlPath($dir).'perex.jpg','upload'));
		else
			$this->set('perex', $this->webroot.'upload/articles/perex.gif');
			
		$this->pageTitle = "Drumb - ARTICLES";
		$this->render('edit', 'admin');
	}

	function view($id = null, $name = null, $page = 1) {
		if($id == null)
		{
			$this->redirect('/error404/');
			exit();
		}
		$this->Article->bindModel (
    	$hasMany = array( 'hasMany' => array(
        	'Comments' => array(
            	'className'  => 'Comment',
	            'foreignKey'    => 'dnb_entry_id',
	            'conditions'    => array('Comments.category' => 'articles'),
	            'order'    => 'created ASC',
	            'limit'        => '0',
	            'dependent'=> false)
    			) 
    		)
    	);
		$data = $this->Article->find('`Article`.`id` = '.$id, null, null, 3);
		
		if(empty($data)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$this->set('data',$data);
		$this->render('index', 'default');
	}
	
	function index($page = 1) {
		//$paging = $this->Pager->getPagerData($this->News->findCount(), $this->Pager->per_page, $page);
		$paging = $this->Pager->getPagerData($this->News->findCount(), $this->Pager->per_page, $page);
		$data = $this->Article->findAll(array('Article.published' => 'Y'), null, array('Article.page DESC'), $paging->limit, $paging->page, $recursive = null);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		
	}
	
	// nahodne zobrazi $limitom dany pocet clankov z archivu - ak nie su definovane $conditions tak sa clanky z aktualneho cisla nezobrazuju.. 
	function getArticles($limit = 3, $conditions = null, $view = 'getArticles') {
		$data = array();
		if($conditions){
			$conditions = $conditions . ' AND ';
		}else {
			$actual = $this->Article->field('Article.dnb_magazine_id','','Article.dnb_magazine_id DESC');
			$conditions = (($actual) ? "Article.dnb_magazine_id != '$actual' AND " : '');
		}
		$data = $this->Article->findAll("$conditions Article.published = 'Y' AND Magazine.published = 'Y'", array('Article.id, Article.header, Article.preview, Article.excerpt, Article.author,ArticleCategory.color'), array('RAND()'), $limit);
		$this->set('data', $data);
		$this->render($view,'ajax');
	}
	
	
	// zobrazi clanky pre jedno cislo casopisu
	function getMagazine($id = null) {
		$data = array();
		$magazine = $this->requestAction('magazines/getMagazine/'.$id);
		$this->set('magazine', $magazine['Magazine']);
		if(isset($magazine['Magazine']['id'])){
			$data = $this->Article->findAll(array("Article.dnb_magazine_id = '{$magazine['Magazine']['id']}'"), array('Article.id','Article.header','Article.author','Article.author_foto','Article.page', 'ArticleCategory.id','ArticleCategory.name','ArticleCategory.color'), 'Article.page ASC' );
		}
		$this->set('data', $data);
	}
	
	// zobrazi posty pre definovanu kategoriu - strankovany vystup
	function getCategoryArticles($id = null, $name = null, $color = null, $page = 1) {
		if($id==null OR $name == null) {
			$this->redirect('/error404/');
			exit();
		}
		$this->Pager->per_page = 15;
		$paging = $this->Pager->getPagerData($this->Article->findCount("Article.dnb_article_category_id='$id' AND Article.published='Y' AND Magazine.published='Y' AND CURDATE() > Magazine.publish_date"), $this->Pager->per_page, $page);
		//$data = $this->Article->findAll("Article.dnb_article_category_id='$id' AND Article.published='Y'", array('Article.id','Article.header','Article.excerpt','Article.author','Article.author_foto','Article.page', 'Magazine.id','Magazine.header','Magazine.publish_date', 'ArticleCategory.id','ArticleCategory.name','ArticleCategory.color'),'ArticleCategory.name ASC', $paging->limit, $paging->page, $recursive = null);
		$data = $this->Article->findAll("Article.dnb_article_category_id='$id' AND Article.published='Y' AND Magazine.published='Y' AND CURDATE() > Magazine.publish_date", array('Article.id','Article.header','Article.page','Article.excerpt','Article.author','Article.author_foto', 'Magazine.id','Magazine.header','Magazine.publish_date','Magazine.published'),'ArticleCategory.name ASC', $paging->limit, $paging->page, $recursive = null);
		//$data = $this->Article->findAll("Article.dnb_article_category_id='$id' AND Article.published='Y'");
		$this->set('data', $data);
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('navigationPages', 5);	
		$this->set('category', array('id'=>$id,'name'=>$name,'color'=>$color));
	}	
	
	
	// zobrazi posty pre defineho autora (zobrazi clanky ktorych je autorom alebo kde fotil fotky..) - vystup strankovany
	function getAuthorArticles($name = null, $page = 1) {
		if($name == null) {
			$this->redirect('/error404/');
			exit();
		}
		$paging = $this->Pager->getPagerData($this->Article->findCount("Article.published='Y' AND (Article.author='$name' OR Article.author_foto='$name') AND Magazine.published='Y' AND CURDATE() > Magazine.publish_date"), $this->Pager->per_page, $page);
		$data = $this->Article->findAll("Article.published='Y' AND (Article.author='$name' OR Article.author_foto='$name') AND Magazine.published='Y' AND CURDATE() > Magazine.publish_date", array('Article.id','Article.header','Article.excerpt','Article.author','Article.author_foto','Article.page', 'Magazine.id','Magazine.header','Magazine.publish_date', 'ArticleCategory.id','ArticleCategory.name','ArticleCategory.color'),'ArticleCategory.name ASC', $paging->limit, $paging->page, $recursive = null);
		$this->set('name', $name);
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('navigationPages', 5);
		$this->set('data', $data);
	}	

	function getUserArticles($page = 0) {
		$this->Auth->checkPermissions();
		$id = $this->Auth->getUser();
		$id = $id['User']['id'];

		$paging = $this->Pager->getPagerData($this->Article->findCount("Article.published='Y' AND Article.dnb_user_id='$id'"), $this->Pager->per_page, $page);
		$data = $this->Article->findAll("Article.published='Y' AND Article.dnb_user_id='$id'", array('Article.id','Article.header','Article.excerpt','Article.author','Article.author_foto','Article.page', 'Magazine.id','Magazine.header','Magazine.publish_date', 'ArticleCategory.id','ArticleCategory.name','ArticleCategory.color'),'ArticleCategory.name ASC', $paging->limit, $paging->page, $recursive = null);
		$user = $this->Article->User->find("`User`.`id` = '".$id."'",array('User.id','User.username','User.name'),null,0);
		$this->set('user', $user);
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('navigationPages', 5);
		$this->set('data', $data);
	}	
	
	// zobrazi clanky ktore neboli publikovane v casopise - vystup strankovany
	function getUnpressedArticles($page = 1) {
		$paging = $this->Pager->getPagerData($this->Article->findCount("Article.published='Y' AND Article.dnb_magazine_id='0'"), $this->Pager->per_page, $page);
		$data = $this->Article->findAll("Article.published='Y' AND Article.dnb_magazine_id='0'", array('Article.id','Article.header','Article.excerpt','Article.author','Article.author_foto','Article.page', 'Magazine.id','Magazine.header','Magazine.publish_date', 'ArticleCategory.id','ArticleCategory.name','ArticleCategory.color'),'Article.created DESC', $paging->limit, $paging->page, $recursive = null);
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('navigationPages', 5);
	}	
	
	function search($text = null) {
		//$data = array();
		//if(isset($this->params['form']['searchText'])) {
			//$paging = $this->Pager->getPagerData($this->Article->findCount("Article.published='Y' AND (Article.header like '%{$this->params['form']['searchText']}%' OR Article.excerpt like '%{$this->params['form']['searchText']}%')"), $this->Pager->per_page, $page);
			$data = $this->Article->findAll("Article.published='Y' AND (Article.header like '%{$this->params['form']['searchText']}%' OR Article.excerpt like '%{$this->params['form']['searchText']}%')",  array('Article.id','Article.header','Article.excerpt','Article.author','Article.author_foto','Article.page', 'Magazine.id','Magazine.header','Magazine.publish_date', 'ArticleCategory.id','ArticleCategory.name','ArticleCategory.color'),'Article.created DESC');//, $paging->limit, $paging->page, $recursive = null);
			//$this->set('page', $paging->page);
			//$this->set('numPages', $paging->numPages);
			$this->set('data', $data);
			$this->set('searchText', $this->params['form']['searchText']);
			//$this->set('navigationPages', 7);
		//}		
	}
	
	
}

?>
