<?php

/**
 * Controller :: Competitions
 *
 * competitions_controler.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */

class CompetitionsController extends AppController
{
    var $name = 'Competitions';
	var $helpers = array('Ajax', 'Form');

	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Competition->setId($id);
		
		if ($this->Competition->saveField('published', 'N')) 
		{
			$this->set('msg','The competition was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The competition was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Competition->setId($id);
		
		if ($this->Competition->saveField('published', 'Y'))
		{
			$this->set('msg','The competition was susccessfully published!');
			$this->set('flag','success');
		}
		else
		{
			$this->set('msg','An error occured. The competition was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->Competition->del($id)) 
		{
			$dir = WWW_ROOT . "upload" . DS . "competitions" . DS . $id . DS;
			$this->Filemanager->deleteDir($dir);
			$this->Competition->delAnswers($id);
			
			$this->set('msg','The competition was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The competition was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_index($page = 1) 
	{	
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Competition->findCount(), $this->Pager->per_page, $page);
		$data = $this->Competition->findAll(null, "header,from_date, to_date, id, published", "published DESC, id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','competitions');
		
		$this->_sessionDel();
		
		$this->pageTitle = "Drumb - COMPETITIONS";
		$this->render('admin', 'admin');
	}
	
	function admin_filter($filter = null, $page = 1) 
	{
		$this->Auth->checkPermissions();

		$paging =$this->Pager->getPagerData($this->Competition->findCount("header LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->Competition->findAll("header LIKE '%".$_GET['filter']."%'", 'published, header, from_date, to_date, id', "published DESC, id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','competition_zone');
		$this->set('filter', $_GET['filter']);
		
		$this->_sessionDel();

		$this->pageTitle = "Drumb - COMPETITIONS";
		$this->render('admin', 'admin');
	}
	
	function admin_add($action = null) 
	{
		$this->Auth->checkPermissions();
		$this->_back('competitions');
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
		
		$this->set('js', $js);
		$this->set('css', $css);
		$this->set('category','competitions');
		$this->set('data', $this->Session->read('data'));
		$this->set('files',  $this->Session->read('files'));
		
		$this->Session->del('data');
		
		$this->pageTitle = "Drumb - COMPETITIONS";
		$this->render('add', 'admin');
	}
	
	function admin_save()
	{
		$this->Auth->checkPermissions();
		@$this->Session->write('redirect', strstr($_SERVER['HTTP_REFERER'], '/admin'));	
		
		if($this->Session->check('id') && empty($this->data['Competition']['id'])) 
		{
			$this->data['Competition']['id'] = $this->Session->read('id');
			$this->Competition->setId($this->data['Competition']['id']);
		}
		else 
			$this->Competition->setId($this->data['Competition']['id']);
		
		if($this->Competition->save($this->data)) 
		{
			if(!$this->Session->check('id') && empty($this->data['Competition']['id'])) 
			{
				$this->Session->write('id' ,mysql_insert_id());
				$this->data['Competition']['id'] = $this->Session->read('id');
			}
			
			$dir = WWW_ROOT . "upload" . DS . "competitions" . DS . $this->data['Competition']['id'] . DS; 
			$this->Filemanager->createDir($dir);
			$this->Session->write('msg','<p class="success">The competition was susccessfully saved!</p>');
		}
		else
			$this->Session->write('msg','<p class="error">An error occured. The competition was not saved!</p>');
		
		$this->Session->write('data',$this->data);
		
		if(isset($this->data['Competition']['upload'])) 
		{
			if(($origin = $this->Filemanager->upload($_FILES['file'], $dir, array('jpg', 'gif', 'jpeg', 'txt', 'doc', 'pdf', 'xls', 'mp3'), 8000000))) 
			{
				$this->Session->write('msg','<p class="success">The file was susccessfully uploaded!</p>');
				$type = pathinfo($origin, PATHINFO_EXTENSION);
				if($type = 'jpg' || $type = 'jpeg' || $type = 'gif') 
				{
					$image = getimagesize($origin);
					if($image[0] > 400)
					{
						$ratio = ($image[0] / $image[1]);
						$image[0] = 400;
						$image[1] =	(400 / $ratio);
						$this->Filemanager->imgResize($origin,$origin,$image[0],$image[1]);
					}
						
				}
			}
			$this->Session->write('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
			$this->redirect($this->Session->read('redirect'));
			exit();
		} 
		else 
			$this->redirect($this->Session->read('redirect'));
	}
	
	function admin_delete_file()
	{	
		$this->Auth->checkPermissions();
		$dir = WWW_ROOT . "upload" . DS . "competitions" . DS . $_POST['id'] . DS . $_POST['name'];
		if($this->Filemanager->deleteFile($dir)) 
		{
			$this->set('msg','The file was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The file was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}

	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->Competition->findCount("`Competition`.`id`=".$id."")) == 0) 
		{
			$this->redirect('/admin/competitions/');
			exit();
		}
		
		$this->Competition->setId($id);
		
		if(!$this->Session->check('data'))
			$data = $this->Competition->read();
		else
			$data = $this->Session->read('data');
		
		$this->Session->del('data');
		
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
		$dir = WWW_ROOT . "upload" . DS . "competitions" . DS . $data['Competition']['id'] . DS;
		$this->_back('competitions');
		
		$this->set('data', $data);
		$this->set('js', $js);
		$this->set('css', $css);
		
		$this->set('category','competitions');
		$this->set('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
		
		$this->pageTitle = "Drumb - COMPETITIONS";
		$this->render('edit', 'admin');
	}
	
	function get_by_tag($tag = null)
	{
		if($tag != null && isset($this->params['requested'])) 
			return $this->Competition->findAll("published = 'Y' AND CURDATE() >= from_date AND CURDATE() <= to_date AND tag LIKE '".$tag."'" ,'id, header, from_date, to_date, popularity', null, 10);
			
	}
	
	function answer($id = null) {
		//pr($_POST);
		if($id == null || empty($this->data) || md5($id) != $this->data['CompetitionAnswer']['security']) {
			$this->redirect('/error404/');
			exit();
		}
		if(isset($this->data['CompetitionAnswer']['photo']['name'])) {
			$this->data['CompetitionAnswer']['file_name'] = $this->data['CompetitionAnswer']['photo']['name'];
		}
		if( $this->Competition->CompetitionAnswer->save($this->data)) {
			$dir = WWW_ROOT."upload".DS."competitions".DS."".$id."".DS;

			$this->Filemanager->createDir($dir);
			$origin = $this->Filemanager->upload($this->data['CompetitionAnswer']['photo'], $dir, array('jpg', 'gif', 'jpeg', 'png'), 20000000);
			if(!empty($origin) && $this->Competition->CompetitionAnswer->save(array('file_name' => basename($origin),'dnb_competition_id' => $id)))
				$this->Session->write('msg2','<p>Vaša fotografia bola zapojená do súťaže!</p>');
			else
				$this->Session->write('msg1','<p>Pridaný obsah nieje povolený!</p>');
			$this->redirect('/competitions/');
		}	
		$data = $this->Competition->find("`Competition`.`id` = '".$id."' AND `Competition`.`published` = 'Y'");
		$this->set('data', $data);
	}
	
	function index() {	
		//return $this->Competition->findAll("published = 'Y' AND CURDATE() >= from_date AND CURDATE() <= to_date" ,'id, header');
		
		$data = $this->Competition->find("`Competition`.`published` = 'Y' AND CURDATE() >= `Competition`.`from_date`", array('Competition.id'), array('Competition.to_date DESC'), 0);
		
		if(empty($data)) {
			//$this->redirect('/error404/');
			//exit();
			$this->render('index', 'default');			
		}else{
			$this->redirect('/competitions/getCompetition/'.$data['Competition']['id']);
		}
		
		//$this->Competition->updatePopularity($data['Competition']['id'], '+');
		//$this->set('data', $data);
		//$answers = $this->requestAction('/competition_answers/getAnswers/'.$data['Competition']['id']);
		//$this->set('answers', $answers);
		
		//$this->render('index', 'default');
	}


	function getCompetition($id=null) {
		if(empty($id)) {
			$this->redirect('/error404/');
			exit();
		}
		
		$data = $this->Competition->find("Competition.published = 'Y' AND Competition.id = '$id' ", null, null, 2);

		$closed = ((strcasecmp($data['Competition']['to_date'], date('Y-m-d')) < 0)?'1':'0');
		$this->set('closed', $closed); 
		
		//pocet hlasov pre kazdu fotku
		$list = array();
		foreach($data['CompetitionAnswer'] as $i=>$v) {
			$data['CompetitionAnswer'][$i]['value'] = 0;
			foreach($v['CompetitionLike'] as $ii=>$vv) {
				$data['CompetitionAnswer'][$i]['value'] += $vv['value'];
			}
			//$list[$data['CompetitionAnswer'][$i]['id']] = $data['CompetitionAnswer'][$i]['value'];
			$list[$i] = $data['CompetitionAnswer'][$i]['value'];
		}
		arsort($list);

		//ohodnotenie fotiek - definovanie od najhorsej fotky po najlepsiu..
		$j = 0;
		foreach($list as $i=>$v){
			$j = $j + $closed;
			$data['CompetitionAnswer'][$i]['top'] = $j;
		}

		$this->set('data', $data);
		$this->render('getCompetition', 'default');
	}
	
	
	function getCompetitions($id = null) {
				
		//$this->Competition->hasMany['CompetitionAnswer']['order'] = 'RAND()';
		//$this->Competition->hasMany['CompetitionAnswer']['limit'] = 1;
		//$data = $this->Competition->findAll("Competition.published = 'Y' AND Competition.id != '$id'", null, null, null, 0, 1);
		$data = $this->Competition->getLikesCount($id);
		if(empty($data)) {
			return '';
		}
		
		$this->set('data', $data);
		$this->render('getCompetitions', 'ajax');
	}
	
	
}

?>