<?php

/**
 * Controller :: Magazines
 *
 * magazines_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $05.02.2007$
 */

class MagazinesController extends AppController
{
    var $name = 'Magazines';
    
	function admin_index($page = 1, $sort = 'Magazine.id', $direction = 'DESC', $filter = null) 
	{				
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Magazine->findCount(), $this->Pager->per_page, $page);
		//$data = $this->Article->table($paging->offset, $paging->limit, $filter, $sort, $direction);
					  //function findAll(null, null, $order = null, $limit = null, $page = 1, $recursive = null) {
		$data = $this->Magazine->findAll($filter, null, $sort.' '.$direction, "".$paging->offset.", ".$paging->limit."");
		
		$this->set('sort', $sort);
		$this->set('direction', $direction);
		$this->set('filter', $filter);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','magazines');
		
		$this->_sessionDel();

		$this->pageTitle = "Drumb - MAGAZINES";
		$this->render('admin', 'admin');
	}
	
	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Magazine->setId($id);
		if ($this->Magazine->saveField('published', 'N')) 
		{
			$this->set('msg','The magazine was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The magazine was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Magazine->setId($id);
		
		if ($this->Magazine->saveField('published', 'Y')) 
		{
			$this->set('msg','The magazine was susccessfully published!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The magazine was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_cover($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Magazine->setId($id);
		if ($this->Magazine->saveField('uncovered', 0)) 
		{
			$this->set('msg','The magazine was susccessfully covered!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The magazine was not covered!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_uncover($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Magazine->setId($id);
		
		if ($this->Magazine->saveField('uncovered',1)) 
		{
			$this->set('msg','The magazine was susccessfully uncovered!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The magazine was not uncovered!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_add()
	{
		$this->Auth->checkPermissions();
		if($this->Magazine->save($this->data))
			$this->Session->write('msg','<p class="success">The magazine was susccessfully added!</p>');
		else
			$this->Session->write('msg','<p class="error">An error occured. The magazine was not added!</p>');
		$this->redirect('/admin/magazines/');
	}
	
	function admin_delete_file()
	{	
		$this->Auth->checkPermissions();
		$dir = WWW_ROOT . "upload" . DS . "magazines" . DS . $_POST['id'] . DS . $_POST['name'];
		if($this->Filemanager->deleteFile($dir)) 
		{
			$this->set('msg','The poster was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The poster was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_edit($id = null)
	{	
		$this->Auth->checkPermissions();
		if(($this->Magazine->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/magazines/');
			exit();
		}
		
		$this->Magazine->setId($id);
		$dir = WWW_ROOT . "upload" . DS . "magazines" . DS . $id . DS; 
		if(empty($this->data))
		{
			$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
			$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
			$js .= '<script type="text/javascript" src="'.$this->webroot.'js/lightbox/spica.php">';
			$js .= '</script><script type="text/javascript" src="'.$this->webroot.'js/lightbox/lightbox_plus.php"></script>';
			$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/lightbox/lightbox.php" />';
			$css .= '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
			
			$this->_back('magazines');
			
			$this->set('data', $this->Magazine->read());
			$this->set('category','magazines');
			$this->set('css', $css);
			$this->set('js', $js);
			$this->set('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
			
			$this->_sessionDel();
			
			$this->pageTitle = "Drumb - MAGAZINES";
			$this->render('edit', 'admin');
		}
		else
		{
			if ($this->Magazine->save($this->data))
				$this->Session->write('msg','<p class="success">The magazine was susccessfully changed!</p>');
			else
				$this->Session->write('msg','<p class="error">An error occured. The magazine was not changed!</p>');
			if(isset($this->data['Magazine']['upload'])) 
			{
				$this->Filemanager->createDir($dir);
				if(($origin = $this->Filemanager->upload($_FILES['file'], $dir, array('jpg', 'gif', 'jpeg'), 500000, 'poster.jpg'))) 
					$this->Session->write('msg','<p class="success">The file was susccessfully uploaded!</p>');
			} 
			$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin').'#msg/');
		}
	}
	
	function admin_get_magazines() 
	{
		$this->Auth->checkPermissions();
		if(isset($this->params['requested']))
			return $this->Magazine->findAll(null, "id, header", "id DESC");
	}
	
	function intro() {
		
		$this->Magazine->bindModel (
    	$hasMany = array( 'hasMany' => array(
        	'Articles' => array(
				'fields' => '*,RAND() as random_record',
            	'className'  => 'Article',
	            'foreignKey'    => 'dnb_magazine_id',
	            'conditions'    => array('Articles.published' => 'Y'),
	            'order'    => 'random_record ASC',
	            'limit'        => '6',
	            'dependent'=> false)
    			) 
    		)
    	);

		$data = $this->Magazine->find( array('Magazine.published' => 'Y'), array ( ), array('Magazine.publish_date DESC'), 1 );
		$this->set('data',$data);
		$this->render('intro','clean');
	}
	
	function index($page = 1) {
		$paging = $this->Pager->getPagerData($this->News->findCount(), $this->Pager->per_page, $page);
		
		$paging =$this->Pager->getPagerData($this->News->findCount(), $this->Pager->per_page, $page);
		$data = $this->News->findAll(array('News.published' => 'Y'), null, array('News.publish_date DESC'), $paging->limit, $paging->page, $recursive = null);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		
	}
	
	// vytiahne data pre zadane cislo casopisu, ak nie je zadane cislo casopisu, vyberie info o najnovsom..
	function getMagazine($id = null, $recursive = 0) {
		$conditions = "Magazine.published = 'Y'";
		$conditions .= (($id) ? " AND Magazine.id = '$id'" : '');
		return $this->Magazine->find($conditions,array(),'Magazine.id DESC', $recursive);
	}
	
	// vytvori archiv jednotlivych cisel vydanych...
	function getArchive() {
		$data = $this->Magazine->findAll("Magazine.published = 'Y'",array(),'Magazine.publish_date DESC', null, null, 0);
		$this->set('data', $data);
	}
	
}

?>