<?php

/**
 * Controller :: Articles
 *
 * routes_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $05.02.2007$
 */

class RoutesController extends AppController
{
    var $name = 'Routes';
	var $helpers = array('Html', 'Form');
    
	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Route->setId($id);
		if ($this->Route->saveField('published', 'N')) 
		{
			$this->set('msg','The route was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The route was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Route->setId($id);
		
		if ($this->Route->saveField('published', 'Y')) 
		{
			$this->set('msg','The route was susccessfully published!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The route was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->Route->del($id)) 
		{
			$dir = WWW_ROOT . "upload" . DS . "Routes" . DS . $id . DS;
			$this->Filemanager->deleteDir($dir);
			$this->Route->delComments('news', $id);
			
			$this->set('msg','The route was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The route was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_index($page = 1) 
	{				
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Route->findCount(), $this->Pager->per_page, $page);
		$data = $this->Route->findAll();
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','routes');

		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - Routes";
		$this->render('admin', 'admin');
	}
	
	function admin_filter() 
	{
		$this->Auth->checkPermissions();
		
		$paging =$this->Pager->getPagerData($this->Route->findCount("header LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->Route->findAll("header LIKE '%".$_GET['filter']."%'");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','routes');
		$this->set('filter', $_GET['filter']);
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - Routes";
		$this->render('admin', 'admin');
	}
	
	function admin_add() 
	{
		$this->Auth->checkPermissions();
		$this->_back('routes','/admin/routes/');	
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
				
		$this->set('js', $js);
		$this->set('category','routes');
		$this->set('data', $this->Session->read('data'));
		$this->set('files',  $this->Session->read('files'));
		
		$this->Session->del('data');
		$this->pageTitle = "Drumb - Routes";
		$this->render('add', 'admin');
	}
	
	function admin_save()
	{
		$this->Auth->checkPermissions();
		@$this->Session->write('redirect', strstr($_SERVER['HTTP_REFERER'], '/admin'));	
		
		if($this->Session->check('id') && empty($this->data['Route']['id'])) 
		{
			$this->data['Route']['id'] = $this->Session->read('id');
			$this->Route->setId($this->data['Route']['id']);
		} 
		else 
			$this->Route->setId($this->data['Route']['id']);
		
		if($this->Route->save($this->data)) 
		{
			if(!$this->Session->check('id') && empty($this->data['Route']['id'])) 
			{
				$this->Session->write('id' ,mysql_insert_id());
				$this->data['Route']['id'] = $this->Session->read('id');
			}
			
			$dir = WWW_ROOT . "upload" . DS . "routes" . DS . $this->data['Route']['id'] . DS; 
			$this->Filemanager->createDir($dir);
			$this->Session->write('msg','<p class="success">The Route was susccessfully saved!</p>');
		}
		else
			$this->Session->write('msg','<p class="error">A error occured. The Route was not saved!</p>');
		
		$this->Session->write('data',$this->data);
		
		if(isset($this->data['Route']['upload'])) 
		{
			if(($origin = $this->Filemanager->upload($_FILES['file'], $dir, array('jpg', 'gif', 'jpeg', 'txt', 'doc', 'pdf', 'xls', 'mp3'), 8000000))) 
			{
				$this->Session->write('msg','<p class="success">The file was susccessfully uploaded!</p>');
				$type = pathinfo($origin, PATHINFO_EXTENSION);
				if($type == 'jpg' || $type == 'jpeg' || $type == 'gif') 
				{
					$image = getimagesize($origin);
					if($image[0] > 400)
					{
						$ratio = ($image[0] / $image[1]);
						$image[0] = 400;
						$image[1] =	(400 / $ratio);
						$this->Filemanager->imgResize($origin,$origin,$image[0],$image[1]);
					}	
				}
			}
			@$this->Filemanager->deleteFile($dir.'perex_temp.jpg');
			$this->Session->write('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
			$this->redirect($this->Session->read('redirect'));
			exit();
		} 
		else
			$this->redirect($this->Session->read('redirect'));
	}

	function admin_delete_file()
	{	
		$this->Auth->checkPermissions();
		$dir = WWW_ROOT . "upload" . DS . "Routes" . DS . $_POST['id'] . DS . $_POST['name'];
		if($this->Filemanager->deleteFile($dir)) 
		{
			$this->set('msg','The file was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The file was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}

	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->Route->findCount("id = '".$id."'")) == 0) 
		{
			$this->redirect('/admin/routes/');
			exit();
		}
		
		$this->Route->setId($id);
		
		if(!$this->Session->check('data'))
			$data = $this->Route->read();
		else 
		{
			$data = $this->Session->read('data');
			$this->Session->del('data');
		}
		
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';

		$dir = WWW_ROOT . "upload" . DS . "routes" . DS . $data['Route']['id'] . DS;
		
		@$this->Filemanager->deleteFile($dir.'perex_temp.jpg');
		$this->_back('routes');
		
		$this->set('data', $data);
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','routes');

		$this->set('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
			
		$this->pageTitle = "Drumb - Routes";
		$this->render('edit', 'admin');
	}
	
	function index($page = 1, $conditions = "Route.published = 'Y'" ) 
	{
		// filter - data
		if(isset($this->data['Rout']['location']) AND ($this->data['Rout']['location'] != '')) $conditions .= " AND Route.location = '{$this->data['Rout']['location']}'"; 
		if(isset($this->data['Rout']['start_point']) AND ($this->data['Rout']['start_point'] != '')) $conditions .= " AND Route.startpoint = '{$this->data['Rout']['start_point']}'"; 
		if(isset($this->data['Rout']['end_point']) AND ($this->data['Rout']['end_point'] != '')) $conditions .= " AND Route.endpoint = '{$this->data['Rout']['end_point']}'"; 
		//pr($conditions);
		
		// Location options
		$location = array();
		$data = $this->Route->findAll("published = 'Y'", ' DISTINCT location');
		foreach($data as $item) {
			$location[$item['Route']['location']] = $item['Route']['location'];
		}
		$this->set('location', $location);

		// Startpoint options
		$startpoint = array();
		$data = $this->Route->findAll("published = 'Y'", ' DISTINCT startpoint');
		foreach($data as $item) {
			$startpoint[$item['Route']['startpoint']] = $item['Route']['startpoint'];
		}
		$this->set('startpoint', $startpoint);

		// Endpoint options
		$endpoint = array();
		$data = $this->Route->findAll("published = 'Y'", ' DISTINCT endpoint');
		foreach($data as $item) {
			$endpoint[$item['Route']['endpoint']] = $item['Route']['endpoint'];
		}
		$this->set('endpoint', $endpoint);

		$paging =$this->Pager->getPagerData($this->Route->findCount(), $this->Pager->per_page, $page);
		$data = $this->Route->findAll($conditions);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->pageTitle = "Drumb - Routes";
		$this->render('index', 'default');
	}
	
	function view($id = null) 
	{
		if($id == null)
		{
			$this->redirect('/error404/');
			exit();
		}
		$this->Route->setId($id);
		$data = $this->Route->read();
		
		$this->set('route', $data);
		$this->pageTitle = "Drumb - Routes";
		$this->render('view', 'default');
	}
}

?>