<?php
/**
 * Controller :: Users
 *
 * users_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $11.02.2007$
 */

class UsersController extends AppController
{
    var $name = 'Users';
	var $components = array('Mailer');
	var $banned_ips = array('196.207.198.219', '41.208.177.210');
	var $banned_mails = array('peace_ojima@yahoo.com', 'blessing_ojima@yahoo.com', '_ojima', 'ojima@', 'mary_mabou');
	
	
	function admin_index($page = 1) 
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->User->findCount("username <> '".$this->Auth->getUserName()."' AND dnb_group_id <> '1'"), $this->Pager->per_page, $page);
		$data = $this->User->findAll("username <> '".$this->Auth->getUserName()."' AND dnb_group_id <> '".ADMIN."'", "id, username, state, last_visit, email, dnb_group_id, ip, online", "id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('groups', $this->requestAction('/admin/groups/get_groups/'));
		$this->set('category','users');
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - USERS";		
		$this->render('admin', 'admin');
	}
	
	function admin_filter() 
	{
		$this->Auth->checkPermissions();
		
		$paging =$this->Pager->getPagerData($this->User->findCount("WHERE username <> '".$this->Auth->getUserName()."' AND dnb_group_id <> '".ADMIN."' AND username LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->User->findAll("WHERE username <> '".$this->Auth->getUserName()."' AND dnb_group_id <> '".ADMIN."' AND username LIKE '%".$_GET['filter']."%'", null, "id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('groups', $this->requestAction('/admin/groups/get_groups/'));
		$this->set('category','users');
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('filter', $_GET['filter']);
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - USERS";
		$this->render('admin', 'admin');
	}
	
	function admin_ban($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->User->setId($id);
		
		if ($this->User->saveField('state', 'banned')) 
		{
			$this->set('msg','The user was susccessfully banned!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The user was not banned!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->User->del($id)) 
		{
			$dir = WWW_ROOT . "upload" . DS . "users" . DS . $id . DS;
			$this->Filemanager->deleteDir($dir);
			$this->User->deleteHistory($id);	
			$this->set('msg','The user was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The artist was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_authorize($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->User->setId($id);
		
		if ($this->User->saveField('state', 'authorized')) 
		{
			$this->set('msg','The user was susccessfully authorized!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The user was not authorized!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_set_group()
	{	
		$this->Auth->checkPermissions();
		$this->User->setId($_POST['id']);
		
		if ($this->User->saveField('dnb_group_id', $_POST['group_id'])) 
		{
			$this->set('msg','The group was susccessfully changed!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The group was not changed!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_login() 
	{
		$result = $this->Auth->login($_POST['login'], $_POST['password']);
			
		if (!$result) 
		{
			$this->set('msg','Bad login or password!');
			$this->set('flag','error');
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			exit();
		}
		
		if ($result == 'banned') 
		{
			$this->set('msg','Your account was banned!');
			$this->set('flag','error');
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			exit();
		}
		
		if ($result == 'inactive') 
		{
			$this->set('msg','Your account is not active!');
			$this->set('flag','error');
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			exit();
		}
		
		exit();
	}
	
	function login() 
	{
		if(empty($_POST)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		if(strlen($_POST['password']) != 40)
			$_POST['password'] = sha1($_POST['password']);
		
		$result = $this->Auth->login($_POST['login'], $_POST['password']);
		
		if (!$result) 
		{
			if(isset($_POST['ajax'])) 
			{
				$this->set('msg','Bad login or password!');
				$this->set('flag','error');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg','<p class="error">Bad login or password!</p>');
		}
		
		if ($result == 'banned') 
		{
			if(isset( $_POST['ajax'])) 
			{
				$this->set('msg','Your account was banned!');
				$this->set('flag','error');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg','<p class="error">Your account was banned!</p>');
		}
		
		if ($result == 'inactive') 
		{
			if(isset( $_POST['ajax'])) 
			{
				$this->set('msg','Your account is not active!');
				$this->set('flag','error');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg','<p class="error">Your account is not active!</p>');
		}
		
		if(isset($_POST['ajax']))
			print 'success';
		else	
			$this->redirect($_SERVER['HTTP_REFERER']);
		exit();
	}
	
	function logout() 
	{
		$this->Auth->logout();
		$this->Session->write('msg','<p class="tick">You have been loged out, have a nice day!</p>');
		$this->redirect('/');
	}
	
	function settings() 
	{
		if(!$this->Auth->validate()) 
		{
			$this->redirect('/error404/');
			exit();
		}

		$this->User->setId($this->Auth->getUserId());
		
	    $data = $this->User->read();
	
	    $dir = WWW_ROOT . "upload" . DS . "users" . DS . $data['User']['id'] . DS;
		if(is_file($dir . 'photo_temp.jpg'))
			$this->Filemanager->deleteFile($dir . 'photo_temp.jpg');
		if(is_file($dir . 'photo_temp.gif'))
			$this->Filemanager->deleteFile($dir . 'photo_temp.gif');
		
		if(empty($data)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$this->set('data', $data);
		$this->render('settings', 'default');		
	}
	
	function save_settings() 
	{
		if(empty($_POST)) 
		{
			$this->redirect('/users/settings/');
			exit();
		}
		
		if(!$this->Auth->validate()) 
		{
			$this->redirect('/error404/');
			exit();
		}
			
		$this->data['User']['age'] = $_POST['age'];
		$this->data['User']['name'] = strip_tags($_POST['name']);
		$this->data['User']['location'] = strip_tags($_POST['location']);

		if(!$this->User->validates($this->data)) 
		{
			if(isset($_POST['ajax'])) 
			{
				$this->set('msg','Age must be a number!');
				$this->set('flag','error_big message_margin');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			 else 
			{
				$this->Session->write('msg_form','<p class="error_big message_margin">Age must be a number!</p>');
				$this->redirect('/users/settings/');
				exit();
			}
		}
		
		if($_POST['new_password_retyped'] != '' || $_POST['new_password'] != '') 
		{
			if($_POST['new_password_retyped'] == $_POST['new_password']) 
			{
				if(strlen($_POST['new_password']) != 40)
					$this->data['User']['passwd'] = sha1($_POST['new_password']);
				else
					$this->data['User']['passwd'] = $_POST['new_password'];
			}
			else
			{
				if(isset($_POST['ajax'])) 
				{
					$this->set('msg','Passwords does not match!');
					$this->set('flag','error_big message_margin');
					$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
					exit();
				}
				else
				{
					$this->Session->write('msg_form','<div id="msg" class="error"><p>Zadané hesla sa nezhodujú!</p></div>');
					$this->redirect('/users/settings/');
					exit();
				}
			}
		}
		
		$this->User->setId($this->Auth->getUserId());
		$dir = WWW_ROOT . "upload" . DS . "users" . DS . $this->Auth->getUserId() . DS;
		if($this->User->save($this->data))
		{
			$this->Auth->setUserFullName($this->data['User']['name']);
			if(isset($_POST['ajax'])) 
			{
				$this->set('msg','Your settings was susccessfully saved!');
				$this->set('flag','tick_big message_margin');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg_form','<div id="msg" class="success"><p>Vaše nastavenia boli úspešne uložené!</p></div>');
		}
		else 
		{
			if(isset($_POST['ajax'])) 
			{
				$this->set('msg','An error occured. Your settings was not saved!');
				$this->set('flag','error_big message_margin');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			} 
			else
				$this->Session->write('msg_form','<div id="msg" class="error"><p>Vaše nastavenia neboli uložené!</p></div>');
		}
		
		if(!empty($_FILES['photo']['name']))
		{
			$max = 4;
			$photos = 0;
			$count = $this->Filemanager->searchDir($dir,0,'FILES');
				
			foreach ($count as $file) 
			{
				if(!strstr($file['File']['name'], strtolower($this->Auth->getUserName())))
					$photos++;
			}
			
			if($photos >= $max)
			{
				$this->Session->write('msg','<p class="error">The photo was not uploaded! Maximal 4 photos allowed!</p>');
				$this->redirect('/users/settings/');
				exit();
			}
				
			if(($dest = $this->Filemanager->upload($_FILES['photo'], $dir, array('jpg', 'gif', 'jpeg'), 1000000))) 
			{				
				$this->Session->write('msg','<p class="tick">The file was susccessfully uploaded!</p>');
				$image = getimagesize($dest);
				if($image[0] > 800)
				{
					$ratio = ($image[0] / $image[1]);
					$image[0] = 800;
					$image[1] =	(800 / $ratio);
					$this->Filemanager->imgResize($dest,$dest,$image[0],$image[1]);
				}
			} 	
		}
		if(!empty($_FILES['file']['name']))
		{
			$this->Filemanager->createDir($dir);
			if(($dest = $this->Filemanager->upload($_FILES['file'], $dir, array('jpg', 'gif', 'jpeg'), 1000000, 'photo_temp.'.strtolower(pathinfo($_FILES['file']['name'], PATHINFO_EXTENSION))))) 
			{				
				$type = pathinfo($dest, PATHINFO_EXTENSION);
				if($type == 'jpg' || $type == 'jpeg' || $type == 'gif')
				{
					$image = getimagesize($dest);
					if($image[1] < 200) 
					{
						$this->Filemanager->imgResize($dest,$dest,((200 * $image[0]) / $image[1]), 200);						
						$image = getimagesize($dest);
					}
					else
						$image = getimagesize($dest);
					if($image[0] < 200)
						$this->Filemanager->imgResize($dest,$dest,200, (200 / ($image[0] / $image[1])));
				}
				$this->Session->write('dest', $dest);
				$this->Session->write('dir', $dir);
				$this->redirect('/users/photo/');
			} 
			else 
				$this->redirect('/users/settings/');
			exit();
		}	
		$this->redirect('/users/settings/');
	}
	
	function photo($action = null) 
	{
		if(!$this->Session->read('dest') || !$this->Session->read('dir') || !$this->Auth->validate()) 
		{
			$this->redirect('/error404/');
			exit();
		}

		$dest = $this->webroot.strstr($this->Filemanager->htmlPath($this->Session->read('dest')),'upload');
		$full_dest = $this->Session->read('dest');
		
		if($action == 'crop')
		{
			if($this->Filemanager->imgCrop($full_dest,$full_dest,$_GET['x'], $_GET['y'], $_GET['width'], $_GET['height'])) 
			{
				if($this->Filemanager->imgResize($full_dest,$this->Session->read('dir').strtolower($this->Auth->getUserName()).'_1.jpg',200,200)) 
				{
					$this->Filemanager->imgResize($full_dest,$this->Session->read('dir').strtolower($this->Auth->getUserName()).'_2.jpg',100,100);
					$this->Filemanager->imgResize($full_dest,$this->Session->read('dir').strtolower($this->Auth->getUserName()).'_3.jpg',60,60);
					$this->Filemanager->imgResize($full_dest,$this->Session->read('dir').strtolower($this->Auth->getUserName()).'_4.jpg',40,40);
					
					$this->Filemanager->deleteFile($full_dest);
					
					$this->Session->write('msg','<p class="tick">Photo was susccessfully croped!</p>');
					$this->Session->write('msg_form','<p class="tick_big message_margin">Your settings was susccessfully saved!</p>');

					$this->Session->del('dest');
					$this->Session->del('dir');
				}
			} 
			else
				$this->Session->write('msg','<p class="error">A error occured. The photo was not croped!</p>');
			
			$this->redirect('/users/settings/');
			exit();
		}
		
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/interface/croper_usr.php" />';
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/interface/interface.php"></script>';
		$image = getimagesize($this->Session->read('dest'));

		if($image[0] > 498) 
		{ 
			$ratio = ($image[0] / $image[1]);
			$image[0] = 498;
			$image[1] =	(498 / $ratio);
			$this->Filemanager->imgResize($full_dest,$full_dest,$image[0],$image[1]);
		}
		
		$data['width'] = $image[0];
		$data['height'] = $image[1];
		$data['dest'] = $dest;
			
		$this->set('data', $data);
		$this->set('dest', $dest);
		$this->set('css', $css);
		$this->set('js', $js);
		
		$this->pageTitle = "PROFILE SETTINGS, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('crop', 'user');
	}
	function get_name($id = null) 
	{
		if(isset($this->params['requested']))
		{
			$this->User->setId($id);
			$name = $this->User->read();
			return $name['User'];
		}	
	}
	function delete_photo($id = null,  $name = null, $ajax = null)
	{
		if($id == null || $name == null || !$this->Auth->validate()) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$data = $this->User->find("id = '".$this->Auth->getUserId()."'", "id");
		
		if($id != $data['User']['id']) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		if($this->Filemanager->deleteFile(WWW_ROOT.'upload'. DS .'users'. DS . $id . DS . $name))
		{
			if($ajax)
			{
				$this->set('msg','The photo was susccessfully deleted!');
				$this->set('flag','tick_big message_margin message_margin');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg_form','<p class="tick_big message_margin">The photo was susccessfully deleted!</p>');
		}
		else 
		{
			if($ajax)
			{
				$this->set('msg','A error occured. The photo was not deleted!');
				$this->set('flag','error message_margin message_margin');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg','<p class="error message_margin">A error occured. The photo was not deleted!</p>');
		}
		$this->redirect('/users/settings/');
	}
	
	function registration() 
	{	
		if($this->Auth->validate()) 
		{
			$this->redirect('/');
			exit();
		}
		
		if(!empty($_POST))
		{
			$this->Session->write('username', $_POST['username']);
			$this->Session->write('email', $_POST['email']);
			$this->Session->write('passwd', $_POST['passwd']);
			$this->Session->write('password_retyped', $_POST['password_retyped']);

			if(empty($_POST['passwd']) || empty($_POST['password_retyped']) || empty($_POST['email']) || empty($_POST['username']))
			{
				$this->Session->write('msg_form','<div id="msg" class="error"><p>Vyplnte všetky polia prosím!</p></div>');
				$this->redirect('/users/registrationForm/');
				exit();
			}
			
			if(!preg_match('/^[A-Za-z0-9_-]+$/', $_POST['username'])) 
			{
				$this->Session->write('msg_form','<div id="msg" class="error"><p>Užívateľské meno môže obsahovať znaky A-Z, 0-9, \'_-\'!</p></div>');
				$this->redirect('/users/registrationForm/');
				exit();
			}
			
			if(strlen($_POST['username']) < 3 || strlen($_POST['username']) > 15) 
			{
				$this->Session->write('msg_form','<div id="msg" class="error"><p>Užívateľské meno musí byť v rozmedzi 3 - 15!</p></div>');
				$this->redirect('/users/registrationForm/');
				exit();
			}
			
			if($this->User->findCount("username = '".$_POST['username']."'") > 0) 
			{
				$this->Session->write('msg_form','<div id="msg" class="error"><p>Zadané užívateľske meno používa niekto iný!</p></div>');
				$this->redirect('/users/registrationForm/');
				exit();
			}
			
			if(!preg_match(VALID_EMAIL, $_POST['email'])) 
			{
				$this->Session->write('msg_form','<div id="msg" class="error"><p>Zadali ste nesprávny format emailu!</p></div>');
				$this->redirect('/users/registrationForm/');
				exit();
			}
			
			if($this->User->findCount("email = '".$_POST['email']."'") > 0) 
			{
				$this->Session->write('msg_form','<div id="msg" class="error"><p>Zadanú emailovú adresu už používa niekto iný!</p></div>');
				$this->redirect('/users/registrationForm/');
				exit();
			}
			
			if($_POST['passwd'] != $_POST['password_retyped']) 
			{
				$this->Session->write('msg_form','<div id="msg" class="error"><p>Zadané hesla sa nezhodujú!</p></div>');
				$this->Session->del('passwd');
				$this->Session->del('password_retyped');
				$this->redirect('/users/registrationForm/');
				exit();
			}
			
			$this->User->save(array('username' => $_POST['username'], 'email' => $_POST['email'], 'passwd' => sha1($_POST['passwd'])));
			
			$this->Mailer->Subject = 'Krasy Slovenska, registracia';
   			$this->Mailer->Message = 'Užívateľ '.$_POST['username'].' bol úspešne zaregistrovaný na portáli <a href="http://www.krasy-slovenska.sk">www.krasy-slovenska.sk</a>. Pre aktiváciu konta kliknite <a href="http://'.SERVER_NAME.'/users/activation/'.$_POST['username'].'/" >sem</a>. Ak sa Vám tento mail zle zobrazil alebo linka nieje klikateľná skopírujte uvedenú linku do prehliadača. http://'.SERVER_NAME.'/users/activation/'.$_POST['username'].'/.';
			$this->Mailer->AddAddress($_POST['username'], trim(strtolower($_POST['email'])));
			$this->Mailer->socketmail();
				
			$this->Session->del('captcha');
			$this->Session->write('msg_form','<div id="msg" class="success"><p>Boli Ste úspešne zaregistrovaný. Na Vami uvedenú emailovú adresu bol poslaný aktyvačný email!</p></div>');
			
			$this->redirect('/users/registrationForm/');
			exit();
		}	
	}
	
	
	function registrationForm() {
		$this->render();
	}
	
	
	function forgot_password()
	{
		if($this->Auth->validate())
		{
			$this->redirect('/news/');
			exit();
		}
		
		if(!empty($_POST))
		{
			$this->Session->write('username', $_POST['username']);
			$this->Session->write('email', $_POST['email']);
			
			if($this->User->findCount("email = '".$_POST['email']."' AND username = '".$_POST['username']."'") > 0 ) 
			{	
				$password = substr(strtolower(sha1(date('Y-m-d H:i:s'))), 0, 8);
				$this->User->savePasswd($_POST['username'],$_POST['email'],sha1($password));
				
				$this->Mailer->Subject = 'Krasy Slovenska, nove heslo';
   			 	$this->Mailer->Message = $_POST['username'].'<br />'.'Vaše nové heslo je '.$password.'. Po prihlásení so ho možete zmeniť.</a>';
				$this->Mailer->AddAddress($_POST['username'],trim(strtolower($_POST['email'])));
				$this->Mailer->socketmail();
								
				$this->Session->write('msg_form','<div id="msg" class="success"><p>Vaše nové heslo bolo odoslané emailom!</p></div>');
				$this->redirect('/zabudnute-heslo/');
				exit();
			}
			else 
			{
				$this->Session->write('msg_form','<div id="msg" class="error"><p>Zadali ste nesprávny email alebo uživateľske meno.</p></div>');
				$this->redirect('/zabudnute-heslo/');
				exit();
			}	
		}
		
		$this->render('forgot_password', 'default');		
	}
	
	function activation($user = null)
	{
		if($this->Auth->validate()) 
		{
			$this->redirect('/');
			exit();
		}
		if($user == null || $this->User->findCount("username = '".$user."'") == 0)
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$data = $this->User->find("username = '".$user."'", "state, id");
		if($data['User']['state'] != 'inactive')
			$this->set('msg_form','<div id="msg" class="info"><p>Vaše konto je aktyvne!</p></div>');
		else
		{
			$this->User->setId($data['User']['id']);
			if($this->User->saveField('state', 'authorized')) 
			{
				
				$this->User->saveField('last_visit', date('Y-m-d H:i:s'));
				$this->set('msg_form','<p class="success">Vaše konto bolo úspešne aktyvované!</p>');
			}	
			else
				$this->set('msg_form','<p class="error">Vyskytla sa chyba Vaše konto nebolo aktyvované!</p>');
		}
		$this->render('activation', 'default');	
	}
}
?>
