<?php

/**
 * Model :: Articles
 *
 * articles.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */

class Article extends AppModel
{
    var $name = 'Article';
    var $tablePrefix = 'dnb_';
	
	var $belongsTo = array(
		'Magazine' => array('className'=>'Magazine', 'foreignKey'=>'dnb_magazine_id' ),
		'ArticleCategory' => array('className'=>'ArticleCategory', 'foreignKey'=>'dnb_article_category_id' ),
		'User' => array('className'=>'User', 'foreignKey'=>'dnb_user_id' ),
	);
	
	function table($offset = 1, $limit = 15, $filter = null, $sort = 'dnb_articles.created', $direction = 'DESC') 
	{
		$sql = 'SELECT dnb_magazines.header, dnb_articles.id, dnb_articles.header, dnb_article_categories.name, ';
		$sql .= 'dnb_articles.published, dnb_articles.comments, dnb_articles.created ';
		$sql .= 'FROM dnb_articles, dnb_magazines, dnb_article_categories ';
		$sql .= 'WHERE dnb_magazines.id = dnb_articles.dnb_magazine_id AND dnb_article_categories.id = dnb_articles.dnb_article_category_id ';
		if($filter != null)
			$sql .= "AND dnb_articles.header LIKE '%".$filter."%' ";
		$sql .= 'ORDER BY '.$sort.' '.$direction.' LIMIT '.$offset.','.$limit.'';	
		return $this->query($sql);
	}
}
?>